OGRE: Ogre::MultiRenderTarget Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::MultiRenderTarget Class Referenceabstract
Core » RenderSystem

This class represents a render target that renders to multiple RenderTextures at once. More...

`#include <OgreRenderTexture.h>`

Inheritance diagram for Ogre::MultiRenderTarget:
[legend]

## Public Types
typedef vector< RenderTexture * >::type | BoundSufaceList
enum | FrameBuffer { FB_FRONT, FB_BACK, FB_AUTO }
enum | StatFlags { SF_NONE = 0, SF_FPS = 1, SF_AVG_FPS = 2, SF_BEST_FPS = 4, SF_WORST_FPS = 8, SF_TRIANGLE_COUNT = 16, SF_ALL = 0xFFFF }

## Public Member Functions
| MultiRenderTarget (const String &name)
virtual void | _beginUpdate ()
| Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc. More...
virtual void | _detachDepthBuffer ()
| Detaches DepthBuffer without notifying it from the detach. More...
virtual void | _endUpdate ()
| Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'. More...
virtual Impl * | _getImpl ()
| Get rendersystem specific interface for this RenderTarget. More...
void | _setMipmapsUpdated (void)
void | _updateViewportCullPhase01 (Viewport *viewport, Camera *renderCamera, Camera *cullCamera, const Camera *lodCamera, uint8 firstRq, uint8 lastRq)
virtual void | _updateViewportRenderPhase02 (Viewport *viewport, Camera *camera, const Camera *lodCamera, uint8 firstRq, uint8 lastRq, bool updateStatistics)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated) More...
virtual void | addListener (RenderTargetListener *listener)
| Add a listener to this RenderTarget which will be called back before & after rendering. More...
virtual Viewport * | addViewport (float left=0.0f, float top=0.0f, float width=1.0f, float height=1.0f)
| Adds a viewport to the rendering target. More...
virtual bool | attachDepthBuffer (DepthBuffer *depthBuffer, bool exactFormatMatch)
| Returns false if couldn't attach. More...
virtual void | bindSurface (size_t attachment, RenderTexture *target)
| Bind a surface to a certain attachment point. More...
virtual void | copyContentsToMemory (const Box &src, const PixelBox &dst, FrameBuffer buffer=FB_AUTO)
| Error throwing implementation, it's not possible to write a MultiRenderTarget to disk. More...
OGRE_DEPRECATED void | copyContentsToMemory (const PixelBox &dst, FrameBuffer buffer=FB_AUTO)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | detachDepthBuffer ()
virtual size_t | getBatchCount (void) const
| Gets the number of batches rendered in the last update() call. More...
RenderTexture * | getBoundSurface (size_t index)
| Get a pointer to a bound surface. More...
const BoundSufaceList & | getBoundSurfaceList () const
| Get a list of the surfaces which have been bound. More...
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute. More...
DepthBuffer * | getDepthBuffer () const
uint16 | getDepthBufferPool () const
| Returns the pool ID this RenderTarget should query from. More...
PixelFormat | getDesiredDepthBufferFormat (void) const
virtual bool | getForceDisableColourWrites (void) const
| Used by depth texture views which need to disable colour writes when rendering to it PF_NULL targets can be identified because they set this value to true and have no depth buffers attached. More...
PixelFormat | getFormat (void) const
virtual void | getFormatsForPso (PixelFormat outFormats[OGRE_MAX_MULTIPLE_RENDER_TARGETS], bool outHwGamma[OGRE_MAX_MULTIPLE_RENDER_TARGETS]) const
virtual uint | getFSAA () const
| Indicates whether multisampling is performed on rendering and at what level. More...
virtual const String & | getFSAAHint () const
| Gets the FSAA hint (. More...
virtual uint32 | getHeight (void) const
virtual void | getMetrics (unsigned int &width, unsigned int &height, unsigned int &colourDepth)
| Retrieve information about the render target. More...
virtual const String & | getName (void) const
| Retrieve target's name. More...
virtual unsigned short | getNumViewports (void) const
| Returns the number of viewports attached to this target. More...
virtual uchar | getPriority () const
| Gets the priority of a render target. More...
virtual const FrameStats & | getStatistics (void) const
virtual size_t | getTriangleCount (void) const
| Gets the number of triangles rendered in the last update() call. More...
virtual Viewport * | getViewport (unsigned short index)
| Retrieves a pointer to the viewport with the given index. More...
virtual uint32 | getWidth (void) const
virtual bool | isActive () const
| Used to retrieve or set the active state of the render target. More...
bool | isFsaaResolveDirty (void) const
virtual bool | isHardwareGammaEnabled () const
| Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space. More...
bool | isMipmapsDirty (void) const
virtual bool | isPrimary (void) const
| Indicates whether this target is the primary window. More...
virtual bool | isRenderWindow (void) const
| Whether our derived class is RenderWindow. More...
virtual bool | isStereoEnabled (void) const
| Indicates whether stereo is currently enabled for this target. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | prefersDepthTexture () const
virtual void | removeAllListeners (void)
| Removes all listeners from this instance. More...
virtual void | removeAllViewports (void)
| Removes all viewports on this target. More...
virtual void | removeListener (RenderTargetListener *listener)
| Removes a RenderTargetListener previously registered using addListener. More...
virtual void | removeViewport (Viewport *vp)
| Removes a viewport at a given Z-order. More...
virtual bool | requiresTextureFlipping () const =0
virtual void | resetStatistics (void)
| Resets saved frame-rate statistices. More...
virtual void | setActive (bool state)
| Used to set the active state of the render target. More...
virtual void | setDepthBufferPool (uint16 poolId)
| Sets the pool ID this RenderTarget should query from. More...
void | setDesiredDepthBufferFormat (PixelFormat desiredDepthBufferFormat)
| Set the desired depth buffer format. More...
virtual void | setFSAA (uint fsaa, const String &fsaaHint)
| Set the level of multisample AA to be used if hardware support it. More...
virtual void | setFsaaResolved ()
virtual void | setFsaaResolveDirty (void)
void | setPreferDepthTexture (bool preferDepthTexture)
| Whether this RT should be attached to a depth texture, or a regular depth buffer. More...
virtual void | setPriority (uchar priority)
| Sets the priority of this render target in relation to the others. More...
PixelFormat | suggestPixelFormat () const
| Irrelevant implementation since cannot copy. More...
virtual void | swapBuffers (void)
| Swaps the frame buffers to display the next frame. More...
virtual void | unbindSurface (size_t attachment)
| Unbind attachment. More...
void | writeContentsToFile (const String &filename, PixelFormat format=PF_UNKNOWN)
| Writes the current contents of the render target to the named file. More...
virtual String | writeContentsToTimestampedFile (const String &filenamePrefix, const String &filenameSuffix, PixelFormat format=PF_UNKNOWN)
| Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file. More...

## Detailed Description

This class represents a render target that renders to multiple RenderTextures at once.

Surfaces can be bound and unbound at will, as long as the following constraints are met:

- All bound surfaces have the same size
- All bound surfaces have the same bit depth
- Target 0 is bound

## Member Typedef Documentation

## ◆ BoundSufaceList

typedef vector<RenderTexture*>::type Ogre::MultiRenderTarget::BoundSufaceList

## Member Enumeration Documentation

## ◆ FrameBuffer

enum Ogre::RenderTarget::FrameBuffer
| inherited

Enumerator
FB_FRONT |
FB_BACK |
FB_AUTO |

## ◆ StatFlags

enum Ogre::RenderTarget::StatFlags
| inherited

Enumerator
SF_NONE |
SF_FPS |
SF_AVG_FPS |
SF_BEST_FPS |
SF_WORST_FPS |
SF_TRIANGLE_COUNT |
SF_ALL |

## Constructor & Destructor Documentation

## ◆ MultiRenderTarget()

Ogre::MultiRenderTarget::MultiRenderTarget | ( | const String & | name | ) |

## Member Function Documentation

## ◆ _beginUpdate()

virtual void Ogre::RenderTarget::_beginUpdate | ( |  | ) |
| virtualinherited

Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.

Remarks
  - _beginUpdate resets statistics and fires 'preRenderTargetUpdate'.
  - _updateViewport renders the given viewport (even if it is not autoupdated), fires preViewportUpdate and postViewportUpdate and manages statistics.
  - _updateAutoUpdatedViewports renders only viewports that are auto updated, fires preViewportUpdate and postViewportUpdate and manages statistics.
  - _endUpdate() ends statistics calculation and fires postRenderTargetUpdate.
  you can use it like this for example :

          renderTarget->_beginUpdate();
          renderTarget->_updateViewport(1); // which is not auto updated
          renderTarget->_updateViewport(2); // which is not auto updated
          renderTarget->_updateAutoUpdatedViewports();
          renderTarget->_endUpdate();
          renderTarget->swapBuffers();

  Please note that in that case, the zorder may not work as you expect, since you are responsible for calling _updateViewport in the correct order.

Reimplemented in Ogre::D3D9RenderWindow.

## ◆ _detachDepthBuffer()

virtual void Ogre::RenderTarget::_detachDepthBuffer | ( |  | ) |
| virtualinherited

Detaches DepthBuffer without notifying it from the detach.

Useful when called from the DepthBuffer while it iterates through attached RenderTargets (

See also
  DepthBuffer::_setPoolId())

Reimplemented in Ogre::GLES2FBOMultiRenderTarget, Ogre::GL3PlusFBORenderTexture, and Ogre::GL3PlusFBOMultiRenderTarget.

## ◆ _endUpdate()

virtual void Ogre::RenderTarget::_endUpdate | ( |  | ) |
| virtualinherited

Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.

Remarks
  You should call it after a _beginUpdate

See also
  _beginUpdate for more details.

Reimplemented in Ogre::D3D9RenderWindow.

## ◆ _getImpl()

virtual Impl* Ogre::RenderTarget::_getImpl | ( |  | ) |
| virtualinherited

Get rendersystem specific interface for this RenderTarget.

This is used by the RenderSystem to (un)bind this target, and to get specific information like surfaces and framebuffer objects.

## ◆ _setMipmapsUpdated()

void Ogre::RenderTarget::_setMipmapsUpdated | ( | void |  | ) |
| inlineinherited

## ◆ _updateViewportCullPhase01()

void Ogre::RenderTarget::_updateViewportCullPhase01 | ( | Viewport * | viewport,
|  | Camera * | renderCamera,
|  | Camera * | cullCamera,
|  | const Camera * | lodCamera,
|  | uint8 | firstRq,
|  | uint8 | lastRq
| ) |  |
| inherited

## ◆ _updateViewportRenderPhase02()

virtual void Ogre::RenderTarget::_updateViewportRenderPhase02 | ( | Viewport * | viewport,
|  | Camera * | camera,
|  | const Camera * | lodCamera,
|  | uint8 | firstRq,
|  | uint8 | lastRq,
|  | bool | updateStatistics
| ) |  |
| virtualinherited

Method for manual management of rendering - renders the given viewport (even if it is not autoupdated)

Remarks
  This also fires preViewportUpdate and postViewportUpdate, and manages statistics if needed. You should call it between _beginUpdate() and _endUpdate().

See also
  _beginUpdate for more details.

Parameters

  viewport | The viewport you want to update, it must be bound to the rendertarget.
  updateStatistics | Whether you want to update statistics or not.

Reimplemented in Ogre::D3D9RenderWindow.

## ◆ addListener()

virtual void Ogre::RenderTarget::addListener | ( | RenderTargetListener * | listener | ) |
| virtualinherited

Add a listener to this RenderTarget which will be called back before & after rendering.

Remarks
  If you want notifications before and after a target is updated by the system, use this method to register your own custom RenderTargetListener class. This is useful for potentially adding your own manual rendering commands before and after the 'normal' system rendering.

NB this should not be used for frame-based scene updates, use Root::addFrameListener for that.

## ◆ addViewport()

virtual Viewport* Ogre::RenderTarget::addViewport | ( | float | left = `0.0f`,
|  | float | top = `0.0f`,
|  | float | width = `1.0f`,
|  | float | height = `1.0f`
| ) |  |
| virtualinherited

Adds a viewport to the rendering target.

Remarks
  A viewport is the rectangle into which rendering output is sent. This method adds a viewport to the render target, rendering from the supplied camera. The rest of the parameters are only required if you wish to add more than one viewport to a single rendering target. Note that size information passed to this method is passed as a parametric, i.e. it is relative rather than absolute. This is to allow viewports to automatically resize along with the target.

Parameters

  cam | The camera from which the viewport contents will be rendered (mandatory)
  ZOrder | The relative order of the viewport with others on the target (allows overlapping viewports i.e. picture-in-picture). Higher Z-orders are on top of lower ones. The actual number is irrelevant, only the relative Z-order matters (you can leave gaps in the numbering)
  left | The relative position of the left of the viewport on the target, as a value between 0 and 1.
  top | The relative position of the top of the viewport on the target, as a value between 0 and 1.
  width | The relative width of the viewport on the target, as a value between 0 and 1.
  height | The relative height of the viewport on the target, as a value between 0 and 1.

## ◆ attachDepthBuffer()

virtual bool Ogre::RenderTarget::attachDepthBuffer | ( | DepthBuffer * | depthBuffer,
|  | bool | exactFormatMatch
| ) |  |
| virtualinherited

Returns false if couldn't attach.

Reimplemented in Ogre::MetalNullTextureTarget, Ogre::MetalDepthTextureTarget, Ogre::GLES2NullTextureTarget, Ogre::GLES2FBOMultiRenderTarget, Ogre::GLES2DepthTextureTarget, Ogre::GL3PlusNullTextureTarget, Ogre::GL3PlusFBORenderTexture, Ogre::GL3PlusFBOMultiRenderTarget, Ogre::GL3PlusDepthTextureTarget, Ogre::D3D11NullTextureTarget, and Ogre::D3D11DepthTextureTarget.

## ◆ bindSurface()

virtual void Ogre::MultiRenderTarget::bindSurface | ( | size_t | attachment,
|  | RenderTexture * | target
| ) |  |
| inlinevirtual

Bind a surface to a certain attachment point.

Parameters

  attachment | 0 .. mCapabilities->getNumMultiRenderTargets()-1
  target | RenderTexture to bind.

It does not bind the surface and fails with an exception (ERR_INVALIDPARAMS) if:

- Not all bound surfaces have the same size
- Not all bound surfaces have the same internal format

## ◆ copyContentsToMemory() [1/2]

virtual void Ogre::MultiRenderTarget::copyContentsToMemory | ( | const Box & | src,
|  | const PixelBox & | dst,
|  | FrameBuffer | buffer = `FB_AUTO`
| ) |  |
| virtual

Error throwing implementation, it's not possible to write a MultiRenderTarget to disk.

Implements Ogre::RenderTarget.

## ◆ copyContentsToMemory() [2/2]

OGRE_DEPRECATED void Ogre::RenderTarget::copyContentsToMemory | ( | const PixelBox & | dst,
|  | FrameBuffer | buffer = `FB_AUTO`
| ) |  |
| inlineinherited

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated:
  This function is deprecated as behavior for dst.size < RenderTarget.size was inconsistent in previous versions of Ogre. Sometimes the whole rect was used as a source, sometimes the rect with the size equal to the size of destination rect but located in the top left corner of the render target, sometimes the destination rect itself. Use the overload with explicitly specified source and destination boxes instead.

References Ogre::RenderTarget::copyContentsToMemory().

Referenced by Ogre::RenderTarget::copyContentsToMemory().

## ◆ detachDepthBuffer()

virtual void Ogre::RenderTarget::detachDepthBuffer | ( |  | ) |
| virtualinherited

Reimplemented in Ogre::MetalDepthTextureTarget, Ogre::GLES2DepthTextureTarget, Ogre::GL3PlusDepthTextureTarget, Ogre::D3D11DepthTextureTarget, Ogre::GLES2FBOMultiRenderTarget, Ogre::GL3PlusFBORenderTexture, and Ogre::GL3PlusFBOMultiRenderTarget.

## ◆ getBatchCount()

virtual size_t Ogre::RenderTarget::getBatchCount | ( | void |  | ) | const
| virtualinherited

Gets the number of batches rendered in the last update() call.

## ◆ getBoundSurface()

RenderTexture* Ogre::MultiRenderTarget::getBoundSurface | ( | size_t | index | ) |
| inline

Get a pointer to a bound surface.

## ◆ getBoundSurfaceList()

const BoundSufaceList& Ogre::MultiRenderTarget::getBoundSurfaceList | ( |  | ) | const
| inline

Get a list of the surfaces which have been bound.

## ◆ getCustomAttribute()

virtual void Ogre::RenderTarget::getCustomAttribute | ( | const String & | name,
|  | void * | pData
| ) |  |
| virtualinherited

Gets a custom (maybe platform-specific) attribute.

Remarks
  This is a nasty way of satisfying any API's need to see platform-specific details. It horrid, but D3D needs this kind of info. At least it's abstracted.

Parameters

  name | The name of the attribute.
  pData | Pointer to memory of the right kind of structure to receive the info.

Reimplemented in Ogre::NULLRenderWindow, Ogre::MetalRenderTexture, Ogre::MetalNullTextureTarget, Ogre::MetalMultiRenderTarget, Ogre::MetalDepthTextureTarget, Ogre::GLES2NullTextureTarget, Ogre::GLES2FBOMultiRenderTarget, Ogre::GLES2DepthTextureTarget, Ogre::NaClWindow, Ogre::X11EGLWindow, Ogre::EGLWindow, Ogre::SDLWindow, Ogre::CocoaWindow, Ogre::GTKWindow, Ogre::GL3PlusNullTextureTarget, Ogre::GL3PlusFBORenderTexture, Ogre::GL3PlusFBOMultiRenderTarget, Ogre::GL3PlusDepthTextureTarget, Ogre::D3D9RenderTexture, Ogre::D3D9RenderWindow, Ogre::D3D9MultiRenderTarget, Ogre::D3D11RenderTexture, Ogre::D3D11RenderWindowBase, Ogre::D3D11NullTextureTarget, Ogre::D3D11MultiRenderTarget, and Ogre::D3D11DepthTextureTarget.

Referenced by Ogre::GL3PlusTexture::getGLID().

## ◆ getDepthBuffer()

DepthBuffer* Ogre::RenderTarget::getDepthBuffer | ( |  | ) | const
| inherited

## ◆ getDepthBufferPool()

uint16 Ogre::RenderTarget::getDepthBufferPool | ( |  | ) | const
| inherited

Returns the pool ID this RenderTarget should query from.

See also
  DepthBuffer

## ◆ getDesiredDepthBufferFormat()

PixelFormat Ogre::RenderTarget::getDesiredDepthBufferFormat | ( | void |  | ) | const
| inherited

See also
  setDesiredDepthBufferFormat

## ◆ getForceDisableColourWrites()

virtual bool Ogre::RenderTarget::getForceDisableColourWrites | ( | void |  | ) | const
| inlinevirtualinherited

Used by depth texture views which need to disable colour writes when rendering to it PF_NULL targets can be identified because they set this value to true and have no depth buffers attached.

Reimplemented in Ogre::MetalNullTextureTarget, Ogre::MetalDepthTextureTarget, Ogre::GLES2NullTextureTarget, Ogre::GLES2DepthTextureTarget, Ogre::GL3PlusNullTextureTarget, Ogre::GL3PlusDepthTextureTarget, Ogre::D3D11NullTextureTarget, and Ogre::D3D11DepthTextureTarget.

## ◆ getFormat()

PixelFormat Ogre::RenderTarget::getFormat | ( | void |  | ) | const
| inherited

## ◆ getFormatsForPso()

virtual void Ogre::MultiRenderTarget::getFormatsForPso | ( | PixelFormat | outFormats[OGRE_MAX_MULTIPLE_RENDER_TARGETS],
|  | bool | outHwGamma[OGRE_MAX_MULTIPLE_RENDER_TARGETS]
| ) |  | const
| virtual

Reimplemented from Ogre::RenderTarget.

## ◆ getFSAA()

virtual uint Ogre::RenderTarget::getFSAA | ( |  | ) | const
| inlinevirtualinherited

Indicates whether multisampling is performed on rendering and at what level.

## ◆ getFSAAHint()

virtual const String& Ogre::RenderTarget::getFSAAHint | ( |  | ) | const
| inlinevirtualinherited

Gets the FSAA hint (.

See also
  Root::createRenderWindow)

## ◆ getHeight()

virtual uint32 Ogre::RenderTarget::getHeight | ( | void |  | ) | const
| virtualinherited

Reimplemented in Ogre::CocoaWindow.

## ◆ getMetrics()

virtual void Ogre::RenderTarget::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height,
|  | unsigned int & | colourDepth
| ) |  |
| virtualinherited

Retrieve information about the render target.

## ◆ getName()

virtual const String& Ogre::RenderTarget::getName | ( | void |  | ) | const
| virtualinherited

Retrieve target's name.

## ◆ getNumViewports()

virtual unsigned short Ogre::RenderTarget::getNumViewports | ( | void |  | ) | const
| virtualinherited

Returns the number of viewports attached to this target.

## ◆ getPriority()

virtual uchar Ogre::RenderTarget::getPriority | ( |  | ) | const
| inlinevirtualinherited

Gets the priority of a render target.

## ◆ getStatistics()

virtual const FrameStats& Ogre::RenderTarget::getStatistics | ( | void |  | ) | const
| virtualinherited

## ◆ getTriangleCount()

virtual size_t Ogre::RenderTarget::getTriangleCount | ( | void |  | ) | const
| virtualinherited

Gets the number of triangles rendered in the last update() call.

## ◆ getViewport()

virtual Viewport* Ogre::RenderTarget::getViewport | ( | unsigned short | index | ) |
| virtualinherited

Retrieves a pointer to the viewport with the given index.

## ◆ getWidth()

virtual uint32 Ogre::RenderTarget::getWidth | ( | void |  | ) | const
| virtualinherited

Reimplemented in Ogre::CocoaWindow.

## ◆ isActive()

virtual bool Ogre::RenderTarget::isActive | ( |  | ) | const
| virtualinherited

Used to retrieve or set the active state of the render target.

Reimplemented in Ogre::SDLWindow, Ogre::CocoaWindow, Ogre::GTKWindow, Ogre::RenderWindow, and Ogre::D3D9RenderWindow.

## ◆ isFsaaResolveDirty()

bool Ogre::RenderTarget::isFsaaResolveDirty | ( | void |  | ) | const
| inlineinherited

Referenced by Ogre::GL3PlusTexture::getGLID().

## ◆ isHardwareGammaEnabled()

virtual bool Ogre::RenderTarget::isHardwareGammaEnabled | ( |  | ) | const
| inlinevirtualinherited

Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.

This is the exact opposite conversion of what is indicated by Texture::isHardwareGammaEnabled, and can only be enabled on creation of the render target. For render windows, it's enabled through the 'gamma' creation misc parameter. For textures, it is enabled through the hwGamma parameter to the create call.

## ◆ isMipmapsDirty()

bool Ogre::RenderTarget::isMipmapsDirty | ( | void |  | ) | const
| inlineinherited

Referenced by Ogre::GL3PlusTexture::getGLID().

## ◆ isPrimary()

virtual bool Ogre::RenderTarget::isPrimary | ( | void |  | ) | const
| virtualinherited

Indicates whether this target is the primary window.

The primary window is special in that it is destroyed when ogre is shut down, and cannot be destroyed directly. This is the case because it holds the context for vertex, index buffers and textures.

Reimplemented in Ogre::RenderWindow.

## ◆ isRenderWindow()

virtual bool Ogre::RenderTarget::isRenderWindow | ( | void |  | ) | const
| inlinevirtualinherited

Whether our derived class is RenderWindow.

Reimplemented in Ogre::RenderWindow.

## ◆ isStereoEnabled()

virtual bool Ogre::RenderTarget::isStereoEnabled | ( | void |  | ) | const
| virtualinherited

Indicates whether stereo is currently enabled for this target.

Default is false.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ prefersDepthTexture()

bool Ogre::RenderTarget::prefersDepthTexture | ( |  | ) | const
| inherited

See also
  setPreferDepthTexture

## ◆ removeAllListeners()

virtual void Ogre::RenderTarget::removeAllListeners | ( | void |  | ) |
| virtualinherited

Removes all listeners from this instance.

## ◆ removeAllViewports()

virtual void Ogre::RenderTarget::removeAllViewports | ( | void |  | ) |
| virtualinherited

Removes all viewports on this target.

## ◆ removeListener()

virtual void Ogre::RenderTarget::removeListener | ( | RenderTargetListener * | listener | ) |
| virtualinherited

Removes a RenderTargetListener previously registered using addListener.

## ◆ removeViewport()

virtual void Ogre::RenderTarget::removeViewport | ( | Viewport * | vp | ) |
| virtualinherited

Removes a viewport at a given Z-order.

## ◆ requiresTextureFlipping()

virtual bool Ogre::RenderTarget::requiresTextureFlipping | ( |  | ) | const
| pure virtualinherited

Implemented in Ogre::NULLRenderTexture, Ogre::MetalDepthTextureTarget, Ogre::GLES2DepthTextureTarget, Ogre::GL3PlusDepthTextureTarget, Ogre::D3D11DepthTextureTarget, Ogre::NULLRenderWindow, Ogre::MetalRenderTexture, Ogre::MetalNullTextureTarget, Ogre::MetalMultiRenderTarget, Ogre::GLES2RenderTexture, Ogre::GLES2NullTextureTarget, Ogre::GLES2FBOMultiRenderTarget, Ogre::NaClWindow, Ogre::EGLWindow, Ogre::SDLWindow, Ogre::CocoaWindow, Ogre::GTKWindow, Ogre::GL3PlusRenderTexture, Ogre::GL3PlusNullTextureTarget, Ogre::GL3PlusFBOMultiRenderTarget, Ogre::D3D9RenderTexture, Ogre::D3D9RenderWindow, Ogre::D3D9MultiRenderTarget, Ogre::D3D11RenderTexture, Ogre::D3D11RenderWindowBase, Ogre::D3D11NullTextureTarget, and Ogre::D3D11MultiRenderTarget.

## ◆ resetStatistics()

virtual void Ogre::RenderTarget::resetStatistics | ( | void |  | ) |
| virtualinherited

Resets saved frame-rate statistices.

## ◆ setActive()

virtual void Ogre::RenderTarget::setActive | ( | bool | state | ) |
| virtualinherited

Used to set the active state of the render target.

## ◆ setDepthBufferPool()

virtual void Ogre::RenderTarget::setDepthBufferPool | ( | uint16 | poolId | ) |
| virtualinherited

Sets the pool ID this RenderTarget should query from.

Default value is POOL_DEFAULT. Set to POOL_NO_DEPTH to avoid using a DepthBuffer (or manually controlling it)

See also
  DepthBuffer

Remarks
  Changing the pool Id will cause the current depth buffer to be detached unless the old id and the new one are the same

Reimplemented in Ogre::MetalDepthTextureTarget, Ogre::GLES2DepthTextureTarget, Ogre::GL3PlusDepthTextureTarget, and Ogre::D3D11DepthTextureTarget.

## ◆ setDesiredDepthBufferFormat()

void Ogre::RenderTarget::setDesiredDepthBufferFormat | ( | PixelFormat | desiredDepthBufferFormat | ) |
| inherited

Set the desired depth buffer format.

Remarks
  Ogre will try to honour this request, but if it's not supported, you may get lower precision. All formats will try to fallback to PF_D24_UNORM_S8_UINT if not supported.

  Changing this setting will cause the current depth buffer to be detached unless the old and the setting are the same.

Parameters

  desiredDepthBufferFormat | Must be one of the following: PF_D24_UNORM_S8_UINT PF_D24_UNORM_X8 PF_D16_UNORM PF_D32_FLOAT PF_D32_FLOAT_X24_S8_UINT

## ◆ setFSAA()

virtual void Ogre::RenderTarget::setFSAA | ( | uint | fsaa,
|  | const String & | fsaaHint
| ) |  |
| inlinevirtualinherited

Set the level of multisample AA to be used if hardware support it.

This option will be ignored if the hardware does not support it or setting can not be changed on the fly on per-target level.

Parameters

  fsaa | The number of samples
  fsaaHint | Any hinting text (

See also
  Root::createRenderWindow)

Reimplemented in Ogre::D3D11RenderWindowSwapChainBased, and Ogre::D3D11RenderWindowBase.

## ◆ setFsaaResolved()

virtual void Ogre::MultiRenderTarget::setFsaaResolved | ( |  | ) |
| virtual

Reimplemented from Ogre::RenderTarget.

## ◆ setFsaaResolveDirty()

virtual void Ogre::MultiRenderTarget::setFsaaResolveDirty | ( | void |  | ) |
| virtual

Reimplemented from Ogre::RenderTarget.

## ◆ setPreferDepthTexture()

void Ogre::RenderTarget::setPreferDepthTexture | ( | bool | preferDepthTexture | ) |
| inherited

Whether this RT should be attached to a depth texture, or a regular depth buffer.

Remarks
  On older GPUs, preferring depth textures may result in certain depth precisions to not be available (or use integer precision instead of floating point, etc).

  Changing this setting will cause the current depth buffer to be detached unless the old and the setting are the same.

Parameters

  preferDepthTexture | True to use depth textures. False otherwise (default).

## ◆ setPriority()

virtual void Ogre::RenderTarget::setPriority | ( | uchar | priority | ) |
| inlinevirtualinherited

Sets the priority of this render target in relation to the others.

Remarks
  This can be used in order to schedule render target updates. Lower priorities will be rendered first. Note that the priority must be set at the time the render target is attached to the render system, changes afterwards will not affect the ordering.

## ◆ suggestPixelFormat()

PixelFormat Ogre::MultiRenderTarget::suggestPixelFormat | ( |  | ) | const
| inlinevirtual

Irrelevant implementation since cannot copy.

Reimplemented from Ogre::RenderTarget.

References Ogre::PF_UNKNOWN.

## ◆ swapBuffers()

virtual void Ogre::MultiRenderTarget::swapBuffers | ( | void |  | ) |
| virtual

Swaps the frame buffers to display the next frame.

Remarks
  For targets that are double-buffered so that no 'in-progress' versions of the scene are displayed during rendering. Once rendering has completed (to an off-screen version of the window) the buffers are swapped to display the new frame.

Reimplemented from Ogre::RenderTarget.

## ◆ unbindSurface()

virtual void Ogre::MultiRenderTarget::unbindSurface | ( | size_t | attachment | ) |
| inlinevirtual

Unbind attachment.

## ◆ writeContentsToFile()

void Ogre::RenderTarget::writeContentsToFile | ( | const String & | filename,
|  | PixelFormat | format = `PF_UNKNOWN`
| ) |  |
| inherited

Writes the current contents of the render target to the named file.

If format is unspecified (PF_UNKNOWN), the most suitable one is automatically chosen.

## ◆ writeContentsToTimestampedFile()

virtual String Ogre::RenderTarget::writeContentsToTimestampedFile | ( | const String & | filenamePrefix,
|  | const String & | filenameSuffix,
|  | PixelFormat | format = `PF_UNKNOWN`
| ) |  |
| virtualinherited

Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

Returns
  the name of the file used.

The documentation for this class was generated from the following file:

- OgreRenderTexture.h